package com.uas.platform.core.concurrent;

import java.util.Vector;

public class Listeners {

	private Vector<Listener> listeners = new Vector<Listener>();

	public synchronized void addListener(Listener e) {
		listeners.addElement(e);
	}

	public synchronized void removeListener(Listener e) {
		listeners.removeElement(e);
	}

	@SuppressWarnings("unchecked")
	public void fire() {
		Vector<Listener> currentListeners = null;
		synchronized (this) {
			currentListeners = (Vector<Listener>) listeners.clone();
		}
		for (int i = 0; i < currentListeners.size(); i++) {
			Listener listener = (Listener) currentListeners.elementAt(i);
			listener.handler();
		}
	}

}
