package com.uas.platform.core.data.repository;

import java.io.Serializable;

import javax.persistence.EntityManager;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.support.JpaRepositoryFactoryBean;
import org.springframework.data.repository.core.support.RepositoryFactorySupport;

/**
 * 自定义Repository工厂构建器
 * 
 * @author yingp
 *
 * @param <T>
 * @param <S>
 * @param <ID>
 */
public class DefaultRepositoryFactoryBean<T extends JpaRepository<S, ID>, S, ID extends Serializable>
		extends JpaRepositoryFactoryBean<T, S, ID> {
	
	protected RepositoryFactorySupport createRepositoryFactory(EntityManager entityManager) {
    	return new DefaultRepositoryFactory(entityManager);
    }
}
