package com.uas.platform.core.data.service;

import java.io.Serializable;

/**
 * service层提供基本业务操作方法的抽象接口
 * 
 * @author yingp
 * 
 * @param <T>
 * @param <ID>
 */
public abstract interface OperationService<T, ID extends Serializable> extends CrudService<T, ID> {

	/**
	 * 按ID查找并审核Entity
	 * 
	 * @param paramID
	 * @return
	 */
	public abstract T audit(ID paramID);

	/**
	 * 审核Entity
	 * 
	 * @param paramS
	 * @return
	 */
	public abstract T audit(T paramS);

	/**
	 * 审核Entities
	 * 
	 * @param paramS
	 * @return
	 */
	public abstract <S extends T> Iterable<S> audit(Iterable<S> paramIterable);

	/**
	 * 按ID查找并反审核Entity
	 * 
	 * @param paramID
	 * @return
	 */
	public abstract T unAudit(ID paramID);

	/**
	 * 反审核Entity
	 * 
	 * @param paramS
	 * @return
	 */
	public abstract T unAudit(T paramS);

	/**
	 * 反审核Entities
	 * 
	 * @param paramS
	 * @return
	 */
	public abstract <S extends T> Iterable<S> unAudit(Iterable<S> paramIterable);

}
