package com.uas.platform.core.data.support;

import java.util.HashMap;
import java.util.Map;

public class EntityFactory {

	private static EntityFactory instance;

	private Map<String, Entity<?>> entities;

	private EntityFactory() {
		entities = new HashMap<String, Entity<?>>();
	}

	public static EntityFactory getFactory() {
		if (instance == null) {
			instance = new EntityFactory();
		}
		return instance;
	}

	@SuppressWarnings("unchecked")
	public <T> Entity<T> getEntity(Class<T> targetCls) {
		Entity<?> entity = entities.get(targetCls.getName());
		if (null == entity) {
			entity = new Entity<T>(targetCls);
			entities.put(targetCls.getName(), entity);
		}
		return (Entity<T>) entity;
	}

}
