package com.uas.platform.core.data.support;

import java.util.HashMap;
import java.util.Map;

/**
 * 记录管理器
 * 
 * @author yingp
 * 
 */
public class OperationLoggerManager {
	private static Map<String, OperationLogger> loggers;

	static {
		loggers = new HashMap<String, OperationLogger>();
	}

	public static OperationLogger getLogger(Class<?> cls) {
		String clsName = cls.getName();
		if (loggers.containsKey(clsName)) {
			return loggers.get(clsName);
		}
		OperationLogger logger = null;
		LoggerParams params = LogUtils.parseAnnotation(cls);
		if (params != null) {
			logger = new OperationLogger(params);
			loggers.put(cls.getName(), logger);
		}
		return logger;
	}

}
