package com.uas.platform.core.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import com.uas.platform.core.data.support.Logable;

@Entity
@Table(name = "log$operation")
public class OperationLog extends Logable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public OperationLog() {
		this.time = new Date();
	}

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@Column(name = "log_id")
	private Long id;

	@Column(name = "log_enuu")
	private Long enUU;

	@Column(name = "log_useruu")
	private Long userUU;

	@Temporal(value = TemporalType.TIMESTAMP)
	@Column(name = "log_time")
	private Date time;

	@Column(name = "log_table")
	private String table;

	@Column(name = "log_key")
	private Long key;

	@Column(name = "log_type")
	private String type;

	@Column(name = "log_desc")
	private String desc;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Long getEnUU() {
		return enUU;
	}

	public void setEnUU(Long enUU) {
		this.enUU = enUU;
	}

	public Long getUserUU() {
		return userUU;
	}

	public void setUserUU(Long userUU) {
		this.userUU = userUU;
	}

	public Date getTime() {
		return time;
	}

	public void setTime(Date time) {
		this.time = time;
	}

	public String getTable() {
		return table;
	}

	public void setTable(String table) {
		this.table = table;
	}

	public Long getKey() {
		return key;
	}

	public void setKey(Long key) {
		this.key = key;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getDesc() {
		return desc;
	}

	public void setDesc(String desc) {
		this.desc = desc;
	}
}
