package com.uas.platform.core.model;

import java.io.Serializable;

public class PageParams implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private int count;
	private int page;
	private String filter;
	private String sorting;

	public int getCount() {
		return count;
	}

	public void setCount(int count) {
		this.count = count;
	}

	public int getPage() {
		return page;
	}

	public void setPage(int page) {
		this.page = page;
	}

	public String getFilter() {
		return filter;
	}

	public void setFilter(String filter) {
		this.filter = filter;
	}

	public String getSorting() {
		return sorting;
	}

	public void setSorting(String sorting) {
		this.sorting = sorting;
	}

	public PageParams(int count, int page, String filter, String sorting) {
		super();
		this.count = count;
		this.page = page;
		this.filter = filter;
		this.sorting = sorting;
	}

	public PageParams() {
		super();
	}

	/**
	 * 封装成分页信息，导出时候需要
	 *
	 * @param pageInfo
	 */
	public PageParams(PageInfo pageInfo) {
		this.count = pageInfo.getPageSize();
		this.page = pageInfo.getPageNumber();
	}

}
