package com.uas.platform.core.model;

/**
 * 状态定义，描述
 * 
 * @author yingp
 * 
 */
/**
 * @author Pro1
 *
 */
public enum Status {
	/**
	 * {@code 100 在录入}
	 */
	INPUTTING(100, "在录入"),
	/**
	 * {@code 101 已提交}
	 */
	SUBMITTED(101, "已提交"),
	/**
	 * {@code 102 已审核}
	 */
	AUDITED(102, "已审核"),
	/**
	 * {@code 103 未通过}
	 */
	NOTALLOW(103, "未通过"),
	/**
	 * {@code 104 已通过}
	 */
	ALLOW(104, "已通过"),
	/**
	 * {@code 111 已结束}
	 */
	FINISH(111, "已结束"),
	/**
	 * {@code 112 已删除}
	 */
	DELETED(112, "已删除"),
	/**
	 * {@code 200 未回复}
	 */
	NOT_REPLY(200, "未回复"),
	/**
	 * {@code 201 已回复}
	 */
	REPLIED(201, "已回复"),
	/**
	 * 202 平台的单据未上传到ERP、SAAS等其它系统
	 */
	NOT_UPLOAD(202, "待上传"),
	/**
	 * 203 ERP、SAAS等其它系统已下载平台的单据
	 */
	DOWNLOADED(203, "已下载"),
	/**
	 * {@code 210 未阅读}
	 */
	NOT_READ(210, "未阅读"),
	/**
	 * {@code 211 已阅读}
	 */
	READ(211, "已阅读"),
	/**
	 * {@code 221 已同意}
	 */
	AGREED(221, "已同意"),
	/**
	 * {@code 222  不同意}
	 */
	NOTAGREED(222, "不同意"),
	/**
	 * {@code 310 未启用}
	 */
	UNAPPLY(310, "未启用"),
	/**
	 * {@code 311 申请中}
	 */
	UNAUDIT(311, "申请中"),
	/**
	 * {@code 312 未激活}
	 */
	UNACT(312, "未激活"),
	/**
	 * {@code 313 已激活}
	 */
	ENABLED(313, "已激活"),
	/**
	 * {@code 314 已禁用}
	 */
	DISABLED(314, "已禁用"),
	/**
	 * {@code 315 已注销,已取消}
	 */
	CANCELLED(315, "已注销"),
	/**
	 * {@code 317 已开账}
	 */
	CREATED(317, "已开账"),
	/**
	 * {@code 350 未完成}
	 */
	PENDING(350, "未完成"),
	/**
	 * {@code 351 运行中}
	 */
	RUNNING(351, "运行中"),
	/**
	 * {@code 400 已发货}
	 */
	SEND(400, "已发货"),
	/**
	 * {@code 401 未发货}
	 */
	UNSEND(401, "未发货"),
	/**
	 * {@code 402 部分发货}
	 */
	PART_SEND(402, "部分发货"),
	/**
	 * {@code 403 出货中}
	 */
	SHIPPINGIN(403, "出货中"),
	/**
	 * {@code 404 待收货}
	 */
	INBOUND(404, "待收货"),
	/**
	 * {@code 405 已收货,只指货物}
	 */
	RECEIVED(405, "已收货"),
	/**
	 * {@code 406 待出货}
	 */
	TOBESHIPPED(406, "待出货"),
	/**
	 * {@code 407 已出货}
	 */
	SHIPPED(407, "已出货"),
	/**
	 * {@code 408 发货中}
	 */
	SENDING(408, "发货中"),
	/**
	 * {@code 409 待回寄}
	 */
	TOBESHIPPEDBACK(409, "待回寄"),
	/**
	 * {@code 410 验货中}
	 */
	INSPECTING(410, "验货中"),

	/**
	 * {@code 411 已验货}
	 */
	INSPECTED(411, "已验货"),

	/**
	 * {@code 412  等待卖家同意}
	 */
	WAITSELLERCOMFIRM(412, "等待卖家同意"),

	/**
	 * {@code 413  卖家接单}
	 */
	ORDERTAKE(413, "卖家接单"),

	/**
	 * {@code 501 待确认}
	 */
	TOBECONFIRMED(501, "待确认"),
	/**
	 * {@code 502 已确认}
	 */
	CONFIRMED(502, "已确认"),
	/**
	 * {@code 503 待付款}
	 */
	TOBEPAID(503, "待付款"),
	/**
	 * {@code 504 已付款}
	 */
	PAID(504, "已付款"),
	/**
	 * {@code 505 已收款}
	 */
	MONEYRECEIVED(505, "已收款"),
	/**
	 * {@code 506 待收款}
	 */
	TORECEIVEMONEY(506, "待收款"),
	/**
	 * {@code 507待退款}
	 */
	TOBEREFUNDED(507, "待退款"),
	/**
	 * {@code 508 已退款}
	 */
	REFUNDED(508, "已退款"),
	/**
	 * {@code 509  退货中}
	 */
	RETURNINGGOODS(509, "退货中"),
	
	/**
	 * {@code 521 退货}
	 */
	RETURN(521, "退货"),
	/**
	 * {@code 510  换货中}
	 */
	EXCHANGEGOODS(510, "换货中"),
	/**
	 * {@code 511  售后中}
	 */
	INAFTERSALES(511, "售后处理中"),
	/**
	 * {@code 512  待开发票}
	 */
	TOBEMADEOUTANINVOICE(512, "待开发票"),
	/**
	 * {@code 511  已开发票}
	 */
	MADEOUTANINVOICE(513, "已开发票"),
	/**
	 * {@code 514  待结算}
	 */
	NOTSETTLED(514, "待结算"),
	/**
	 * {@code 515  已结算}
	 */
	SETTLED(515, "已结算"),
	/**
	 * {@code 516  已到结算期}
	 */
	CHECKDEADLINE(516, "已到结算期"),
	/**
	 * {@code 517  未到结算期}
	 */
	NOCHECKDEADLINE(517, "未到结算期"),
	/**
	 * {@code 518  已送样}
	 */
	PROOFED(518, "已送样"),
	/**
	 * {@code 520 已完成}
	 */
	COMPLETED(520, "已完成"),
	/**
	 * {@code 521 待评论}
	 */
	TO_BE_REVIEWED(521, "待评论"),
	/**
	 * {@code 521 待评论}
	 */
	TO_BE_AFTERREVIEWED(523, "待追评"),
	/**
	 * {@code 522 已评论}
     */
	REVIEWED(522, "已评论"),
	/**
	 * {@code 601  有效的}
	 */
	AVAILABLE(601, "有效地"),
	/**
	 * {@code 602 无效的(因库存不足而失效)}
	 */
	UNAVAILABLE(602, "无效的(因库存不足而失效)"),
	/**
	 * {@code 603 无效的（因未按时付款）}
	 */
	UNAVAILABLE_NOPAID(603, "无效的（因未按时付款）"),

	/**
	 * {@code 604  无效的（因供应商拒绝）}
	 */
	UNAVAILABLE_DISAGREE(604, "无效的（因供应商拒绝）"),

	/**
	 * {@code 605 无效的（因全部退货完成的）}
	 */
	UNAVAILABLE_RETURN(605, "无效的（因全部退货完成的）"),
	/**
	 * {@code 606 无效的（因用户本人取消而失效）}
	 */
	UNAVAILABLE_PERSONAL(606, "无效的（因用户本人取消而失效）"),
	/**
	 * {@code 607 申请议价中}
	 */
	CHARGE_APPLY(607, "申请议价中"),
	/**
	 * {@code 608 议价结束(同意)}
	 */
	CHARGE_ACCEPT(608, "议价结束(同意)"),
	/**
	 * {@code 609 议价结束(不同意)}
	 */
	CHARGE_REFUSE(609, "议价结束(不同意)"),

	/**
	 * {@code 610   确认状态取消（确认状态下供应商拒绝取消）}
	 */
	COMFIRM_DISAGREE(610, " 确认状态取消（供应商拒绝取消）"),

	/**
	 * {@code 611   已付款状态取消（已付款状态下供应商拒绝取消）}
	 */
	PAIDED_DISAGREE(611, "已付款状态取消（供应商拒绝取消）"),

	/**
	 * {@code 612 已下架}
	 */
	REMOVED(612, "已下架"),

	/*
	 * {@code 699 待开发票}
	 */
	PREPARE_BILL(699, "准备发票"),

	/*
	 * {@code 700 待开发票}
	 */
	TOBEMAKE_BILL(700, "待开发票"),

	/**
	 * {@code 701  待收发票} 如果在订单主表代表，已经全部开票，存在待收票的明细 如果在明细表，代表这条明细已经开票，处于待确认收票状态
	 */
	TOBERECEIVE_BILL(701, "待收发票"),

	/*
	 * {@code 702 已收发票}
	 */
	RECEIVED_BILL(702, "已收发票"),

	/*
	 * {@code 703 不需开票}
	 */
	NEEDNO_BILL(703, "不需开票"),

	/*
	 * {@code 704 存在待收票的订单} 区别与701 701状态代表订单中不存在待开票的明细；而704代表订单中可能存在待开票的明细
	 */
	TOCONFIRM_BILL(704, "存在待收票的订单"),

	/*
	 * {@code 705 已开票的全部收票}
	 */
	OPENED_RECEIVED_BILL(705, "已开票的全部收票"),

	/**
	 * {@code 810 创客需求问题待处理}
	 */
	TOBE_HANDLE(810, "未处理"),

	/**
	 * {@code 811 创客需求问题已处理}
	 */
	HANDLED(811, "已处理"),

	/**
	 * {@code 812 待爬取}
	 */
	TO_CROWL(812, "未完成"),

	/**
	 * {@code 813 已爬取}
	 */
	CROWLED(813, "已完成"),

	/**
	 * {@code 814 爬取失败}
	 */
	CROWLED_FAILED(814, "任务失败"),
	/**
	 * {@code 1669 待入库 <b>待入库</b>}
	 */
	TOBE_LOAD(1669, "待入库"),

	/**
	 * {@code 1670 待上架 <b>待上架</b>}
	 */
	TOBE_ONSALE(1670, "未上架"),

	/**
	 * {@code 1680 未读 <b>未读</b>}
	 */
	UNREAD(1680, "未读"),

	/**
	 * {@code 1690 1690 <b>1690</b>}
	 */
	ISREAD(1690, "已读");

	/**
	 * @param value
	 *            状态编号
	 *            <p>
	 *            100~199 <i>单据基本状态</i>
	 *            </p>
	 *            <p>
	 *            200~299 <i>沟通状态</i>
	 *            </p>
	 *            <p>
	 *            300~399 <i>用户使用状态</i>
	 *            </p>
	 *            <p>
	 *            400~499 <i>物流状态</i>
	 *            </p>
	 *            <p>
	 *            500~599 <i>单据状态</i>
	 *            </p>
	 * @param phrase
	 *            描述
	 */
	private Status(int value, String phrase) {
		this.value = value;
		this.phrase = phrase;
	}

	private final int value;

	private final String phrase;

	/**
	 * @return 状态的整型编码
	 */
	public int value() {
		return this.value;
	}

	/**
	 * @return 状态的描述
	 */
	public String getPhrase() {
		return this.phrase;
	}

	/**
	 * @param statusCode
	 *            状态的编码
	 * @return 状态
	 * @throws IllegalArgumentException
	 *             如果statusCode不存在的话
	 */
	public static Status valueOf(int statusCode) {
		for (Status status : values()) {
			if (status.value == statusCode) {
				return status;
			}
		}
		throw new IllegalArgumentException("没有与编号 [" + statusCode + "]匹配的状态");
	}

	/**
	 * 返回状态的编号
	 */
	@Override
	public String toString() {
		return Integer.toString(value);
	}

	/**
	 * 判断订单或采购单的当前状态是否处于已失效状态
	 *
	 * @return	如果已失效，则返回true
	 */
	public static boolean isUnavailable(Integer status) {
		return Status.UNAVAILABLE.value() == status || Status.UNAVAILABLE_DISAGREE.value() == status || Status.UNAVAILABLE_NOPAID.value() == status
				|| Status.UNAVAILABLE_PERSONAL.value() == status || Status.UNAVAILABLE_RETURN.value() == status || Status.RETURN.value() == status;
	}
}
