package com.uas.platform.core.model;

/**
 * 类型定义，描述
 * 
 * @author chenhao
 * 
 */

public enum Type {
	/**
	 * {@code 1001  收货地址}
	 */
	Address_Shipping_Code(1001, "收货地址"),
	/**
	 * {@code 1002 发货地址}
	 */
	Address_Sending_Code(1002, "发货地址"),
	/**
	 * {@code 1011  增加}
	 */
	Add_Code(1011, "增加"),
	/**
	 * {@code 1012 扣除}
	 */
	Subtract_Code(1012, "扣除"),
	/**
	 * {@code 1021  退货}
	 */
	Return_Goods_Code(1021, "退货"),
	/**
	 * {@code 1022 换货}
	 */
	Exchange_Goods_Code(1022, "换货"),
	/**
	 * {@code 1030 平台销售换货单}
	 */
	Purc_B2c_Change_Code(1030, "平台销售换货单"),
	/**
	 * {@code 1031供应商销售换货单}
	 */
	Purc_Vender_Change_Code(1031, "供应商销售换货单"),
	/**
	 * {@code 1032平台销售退货单}
	 */
	Purc_B2c_Return_Code(1032, "平台销售退货单"),
	/**
	 * {@code 1033供应商销售退货单}
	 */
	Purc_Vender_Return_Code(1033, "供应商销售退货单"),
	/**
	 * {@code 1034平台销售验收单}
	 */
	Purc_B2c_Accept_Code(1034, "平台销售验收单"),
	/**
	 * {@code 1035供应商出货单}
	 */
	Invoice_Vender_code(1035, "供应商出货单"),
	/**
	 * {@code 1036平台出货单}
	 */
	Invoice_B2c_code(1036, "平台出货单"),
	/**
	 * {@code 1037供应商换货出货单}
	 */
	Invoice_Vender_Change_code(1037, "供应商换货出货单"),
	/**
	 * {@code 1038平台换货出货单}
	 */
	Invoice_B2c_Change_code(1038, "平台换货出货单"),
	/**
	 * {@code 1039订单}
	 */
	Order_code(1039, "订单"),
	/**
	 * {@code 1040采购订单}
	 */
	Purchase_code(1040, "采购单"),
	/**
	 * {@code 1041客户退货单}
	 */
	Return_Cust_code(1041, "客户退货单"),
	/**
	 * {@code 1042平台退货单}
	 */
	Return_B2c_code(1042, "平台退货单"),
	/**
	 * {@code 1043客户换货单}
	 */
	Change_Cust_code(1043, "客户换货单"),
	/**
	 * {@code 1044平台换货单}
	 */
	Change_B2c_code(1044, "平台换货单"),
	/**
	 * {@code 1051  现货}
	 */
	Spot_Code(1051, "现货"),
	/**
	 * {@code 1052 期货}
	 */
	Futures_Code(1052, "期货"),
	/**
	 * {@code 1053  进口额外支付费率}
	 */
	EXTRA_CHARGE_RATE_IN_IMPORT(1053, "进口额外支付费率"),

	/**
	 * {@code 1054 提醒卖家发货的类型}
	 */
	NOTIFY_SELLER_SHIP(1054, "提醒卖家发货的类型"),
	/**
	 * {@code 1061  买家}
     */
	BUYER(1061, "买家"),
	/**
	 * {@code 1062  商城}
	 */
	MALL(1062, "商城"),
	/**
	 * {@code 1063  卖家}
	 */
	SUP(1063, "卖家"),
	/**
	 * {@code 1101 货到付款}
	 */
	Payment_CashOnDelivery_Code(1101, "货到付款"),
	/**
	 * {@code 1102 在线支付}
	 */
	Payment_Online_Code(1102, "在线支付"),
	/**
	 * {@code 1103 公司转账}
	 */
	Payment_CompanyTransfer_Code(1103, "公司转账"),
	/**
	 * {@code 1104 邮局汇款}
	 */
	Payment_Remittance_Code(1104, "邮局汇款"),
	/**
	 * {@code 120117%增值税可抵扣，累计开票,8%税点}
	 */
	Bill_DeductibleCumulative_Code(1201, "17%增值税可抵扣，累计开票,8%税点"),
	/**
	 * {@code 1202 17%增值税不可抵扣，累计开票,8%税点}
	 */
	Bill_NoDeductibleCumulative_Code(1202, "17%增值税不可抵扣，累计开票,8%税点"),
	/**
	 * {@code 1203 17%增值税可抵扣，随元器件一起发货,10%税点}
	 */
	Bill_DeductibleNoCumulative_Code(1203, "17%增值税可抵扣，随元器件一起发货,10%税点"),
	/**
	 * {@code 1204 17%增值税不可抵扣，，随元器件一起发货,10%税点}
	 */
	Bill_NoDeductibleNoCumulative_Code(1204, "17%增值税不可抵扣，，随元器件一起发货,10%税点"),
	/**
	 * {@code 1205 增值税专用发票}
	 */
	Bill_Deduct(1205, "增值税专用发票"),

	/**
	 * {@code 1205 增值税普通发票}
	 */
	Bill_NoDeduct(1206, "增值税普通发票"),

	/**
	 * {@code 1207 不需要开票}
	 */
	Bill_No(1207, "不需要开票"),
	/**
	 * {@code 1301 UU配送}
	 */
	Delivery_ByUU_Code(1301, "UU配送"),
	/**
	 * {@code 1302 上门自取}
	 */
	Delivery_BySelf_Code(1302, "上门自取"),

	/**
	 * {@code 1311 现货 <b>上架商品类型</b>}
	 */
	Goods_Original_Code(1311, "现货"),

	/**
	 * {@code 1312 呆滞库存 <b>上架商品类型</b>}
	 */
	Goods_Inaction_Stock(1312, "呆滞库存"),

	/**
	 * {@code 1313 废料 <b>上架商品类型</b>}
	 */
	// Goods_Wastage_Code(1313, "废料"),

	/**
	 * {@code 1401 订单发票}
	 */
	ORDER_BILL(1401, "订单发票"),
	
	/**
	 * {@code 1402 采购单发票}
	 */
	PURCHASE_BILL(1402, "采购单发票"),
	
	/**
	 * {@code 1500  买家待支付时间}
	 */
	
	B2C_PROPERTY_PAYTIEM(1500, "买家付款有效期"),

	/**
	 * {@code 1501 买家收货后转变成已完成状态的时间}
	 */
	B2C_PROPERTY_COMPLETETIME(1501, "买家收货后转变为已完成时间"),

	/**
	 * {@code 1502  买家自动收货的时间}
	 */
	B2C_AUTO_RECEVIED_TIME(1502, "买家自动收货的时间"),

	/**
	 * 站内信接受角色（卖家）
	 */
	SELLER(1507, "SELLER"),

	/**
	 * 站内信类型（公告）
	 */
	PUBLIC(1505, "PUBLIC"),

	/**
	 * 站内信类型（私信）
	 */
	PRIVATE(1506, "PRIVATE"),

	/**
	 * {@code 1401 订单发票}
	 */
	EXCHANGERATE_USD(1600, "USD"),

	/**
	 * 个人行为
	 */
	PERSONAL(1601, "PERSONAL"),

	/**
	 * 企业行为
	 */
	ENTERPRISING(1602, "ENTERPRISING"),

	/**
	 * {@code 1666 企业入库 <b>企业入库</b>}
	 */
	STOCK_IN(1666, "入库动作"),

	/**
	 * {@code 1667 企业出库 <b>企业出库</b>}
	 */
	STOCK_OUT(1667, "出库动作"),

	/**
	 * {@code 1668 企业销售出库 <b>企业销售出库</b>}
	 */
	STOCK_SELLER(1668, "销售出库");

	/**
	 * @param value
	 *            状态编号
	 *            <p>
	 *            1000~1099 <i>交易相关</i>
	 *            </p>
	 *            <p>
	 *            1100~1199 <i>支付方式</i>
	 *            </p>
	 *            <p>
	 *            1200~1299 <i>票据类型</i>
	 *            </p>
	 *            <p>
	 *            1300~1399 <i>配送类型</i>
	 *            </p>
	 * @param phrase
	 *            描述
	 */
	private Type(int value, String phrase) {
		this.value = value;
		this.phrase = phrase;
	}

	private final int value;

	private final String phrase;

	/**
	 * @return 状态的整型编码
	 */
	public int value() {
		return this.value;
	}

	/**
	 * @return 状态的描述
	 */
	public String getPhrase() {
		return this.phrase;
	}

	/**
	 * @param statusCode
	 *            状态的编码
	 * @return 状态
	 * @throws IllegalArgumentException
	 *             如果statusCode不存在的话
	 */
	public static Type valueOf(int statusCode) {
		for (Type status : values()) {
			if (status.value == statusCode) {
				return status;
			}
		}
		throw new IllegalArgumentException("没有与编号 [" + statusCode + "]匹配的状态");
	}

	/**
	 * 返回状态的编号
	 */
	@Override
	public String toString() {
		return Integer.toString(value);
	}
}
