package com.uas.platform.core.persistence;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import com.uas.platform.core.model.Operation;

/**
 * 自动记录操作日志
 * 
 * @author yingp
 * 
 */
@Documented
@Target({ ElementType.TYPE })
@Retention(RetentionPolicy.RUNTIME)
public @interface Logger {

	/**
	 * 操作
	 * 
	 * @return
	 */
	public abstract Operation[] operation() default { Operation.INSERT, Operation.UPDATE, Operation.DELETE };

	public abstract String enUU() default "";
	
	public abstract String userUU() default "";

}
