package com.uas.platform.core.web.bind;

import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

/**
 * Request里面参数标志<br>
 * 弥补RequestMethod的不足<br>
 * 格式为_method={{Operation}}
 * 
 * @see RequestMapping
 * @see RequestMethod
 * 
 * @author yingp
 * 
 */
public class RequestParams {

	static final String paramName = "_method";

	/**
	 * 批量操作
	 */
	public static final String ALL = "all";

	/**
	 * 审核操作
	 */
	public static final String AUDIT = paramName + "=audit";

	/**
	 * 批量审核操作
	 */
	public static final String AUDIT_ALL = paramName + "=audit_all";

	/**
	 * 反审核操作
	 */
	public static final String UNAUDIT = paramName + "=unaudit";

	/**
	 * 批量反审核操作
	 */
	public static final String UNAUDIT_ALL = paramName + "=unaudit_all";
}
